local T, C, L, _ = unpack(select(2, ...))
if C.skins.blizzard_frames ~= true then return end

----------------------------------------------------------------------------------------
--	AuctionUI skin
----------------------------------------------------------------------------------------
local function LoadSkin()
	T.SkinCloseButton(AuctionFrameCloseButton)
	AuctionFrame:StripTextures(true)
	AuctionFrame:SetTemplate("Transparent")

	BrowseTitle:ClearAllPoints()
    BrowseTitle:SetPoint("TOP", AuctionFrame, "TOP", 0, -6)

	BidTitle:ClearAllPoints()
    BidTitle:SetPoint("TOP", AuctionFrameBid, "TOP", 37, -6)

	AuctionsTitle:ClearAllPoints()
    AuctionsTitle:SetPoint("TOP", AuctionFrameAuctions, "TOP", 37, -6)

	BrowseFilterScrollFrame:StripTextures()
	BrowseScrollFrame:StripTextures()
	AuctionsScrollFrame:StripTextures()
	BidScrollFrame:StripTextures()

	T.SkinScrollBar(BrowseFilterScrollFrameScrollBar)
	T.SkinScrollBar(BrowseScrollFrameScrollBar)
	T.SkinScrollBar(AuctionsScrollFrameScrollBar)
	T.SkinScrollBar(BidScrollFrameScrollBar)

	T.SkinDropDownBox(BrowseDropDown)
	T.SkinDropDownBox(PriceDropDown)
	-- T.SkinDropDownBox(DurationDropDown, 80)

	T.SkinCheckBox(IsUsableCheckButton)
	T.SkinCheckBox(ShowOnPlayerCheckButton)
	-- T.SkinCheckBox(ExactMatchCheckButton)

	-- Dress Up Frame
	AuctionFrame:HookScript("OnShow", function()
		SideDressUpFrame:StripTextures(true)
		SideDressUpFrame:SetTemplate("Transparent")

		SideDressUpFrame:ClearAllPoints()
		SideDressUpFrame:SetPoint("TOPLEFT", AuctionFrame, "TOPRIGHT", 3, 0)

		SideDressUpModelResetButton:SkinButton()
		T.SkinCloseButton(SideDressUpModelCloseButton)
		SideDressUpModelCloseButton:SetPoint("TOPRIGHT", 6, 8)
	end)

	-- WoW Token
	-- WowTokenGameTimeTutorial.NineSlice:Hide()
	WowTokenGameTimeTutorial.TitleBg:Hide()
	WowTokenGameTimeTutorial:CreateBackdrop("Transparent")
	-- WowTokenGameTimeTutorialInset.NineSlice:Hide()
	WowTokenGameTimeTutorialBg:Hide()
	StoreButton:SkinButton()
	T.SkinCloseButton(WowTokenGameTimeTutorial.CloseButton)

	BrowseWowTokenResults.Buyout:SkinButton(true)
	local Token = BrowseWowTokenResultsToken
	Token.ItemBorder:Hide()
	Token.IconBorder:Hide()
	Token.Icon:SetTexCoord(0.1, 0.9, 0.1, 0.9)
	Token:CreateBackdrop("Default")
	Token.backdrop:SetPoint("TOPLEFT", Token.IconBorder, -2, 2)
	Token.backdrop:SetPoint("BOTTOMRIGHT", Token.IconBorder, 2, -2)

	-- Progress Frame
	AuctionProgressFrame:StripTextures()
	AuctionProgressFrame:SetTemplate("Transparent")
	AuctionProgressFrameCancelButton:StyleButton()
	AuctionProgressFrameCancelButton:SetTemplate("Default")
	AuctionProgressFrameCancelButton:SetHitRectInsets(0, 0, 0, 0)
	AuctionProgressFrameCancelButton:GetNormalTexture():ClearAllPoints()
	AuctionProgressFrameCancelButton:GetNormalTexture():SetPoint("TOPLEFT", 2, -2)
	AuctionProgressFrameCancelButton:GetNormalTexture():SetPoint("BOTTOMRIGHT", -2, 2)
	AuctionProgressFrameCancelButton:GetNormalTexture():SetTexCoord(0.67, 0.37, 0.61, 0.26)
	AuctionProgressFrameCancelButton:SetSize(28, 28)
	AuctionProgressFrameCancelButton:SetPoint("LEFT", AuctionProgressBar, "RIGHT", 8, 0)

	AuctionProgressBar.Icon:SetTexCoord(0.1, 0.9, 0.1, 0.9)

	local backdrop = CreateFrame("Frame", nil, AuctionProgressBar.Icon:GetParent())
	backdrop:SetPoint("TOPLEFT", AuctionProgressBar.Icon, "TOPLEFT", -2, 2)
	backdrop:SetPoint("BOTTOMRIGHT", AuctionProgressBar.Icon, "BOTTOMRIGHT", 2, -2)
	backdrop:SetTemplate("Default")
	AuctionProgressBar.Icon:SetParent(backdrop)

	AuctionProgressBar.Text:ClearAllPoints()
	AuctionProgressBar.Text:SetPoint("CENTER")

	AuctionProgressBar:StripTextures()
	AuctionProgressBar:CreateBackdrop("Default")
	AuctionProgressBar:SetStatusBarTexture(C.media.texture)
	AuctionProgressBar:SetStatusBarColor(1, 1, 0)

	T.SkinNextPrevButton(BrowseNextPageButton)
	T.SkinNextPrevButton(BrowsePrevPageButton)

	local buttons = {
		"BrowseBidButton",
		"BidBidButton",
		"BrowseBuyoutButton",
		"BidBuyoutButton",
		"BrowseCloseButton",
		"BidCloseButton",
		"BrowseSearchButton",
		"AuctionsCreateAuctionButton",
		"AuctionsCancelAuctionButton",
		"AuctionsCloseButton",
		"BrowseResetButton",
		"AuctionsStackSizeMaxButton",
		"AuctionsNumStacksMaxButton"
	}

	for _, button in pairs(buttons) do
		_G[button]:SkinButton(true)
	end

	-- Fix Button Positions
	AuctionsCloseButton:SetPoint("BOTTOMRIGHT", AuctionFrameAuctions, "BOTTOMRIGHT", 66, 10)
	AuctionsCancelAuctionButton:SetPoint("RIGHT", AuctionsCloseButton, "LEFT", -4, 0)
	BidCloseButton:SetPoint("BOTTOMRIGHT", AuctionFrameBid, "BOTTOMRIGHT", 66, 10)
	BidBuyoutButton:SetPoint("RIGHT", BidCloseButton, "LEFT", -4, 0)
	BidBidButton:SetPoint("RIGHT", BidBuyoutButton, "LEFT", -4, 0)
	BrowseCloseButton:SetPoint("BOTTOMRIGHT", AuctionFrameBrowse, "BOTTOMRIGHT", 66, 10)
	BrowseBuyoutButton:SetPoint("RIGHT", BrowseCloseButton, "LEFT", -4, 0)
	BrowseBidButton:SetPoint("RIGHT", BrowseBuyoutButton, "LEFT", -4, 0)
	BrowseSearchButton:ClearAllPoints()
	BrowseSearchButton:SetPoint("TOPRIGHT", AuctionFrameBrowse, "TOPRIGHT", 52, -28)
	BrowseSearchButton:SetWidth(130)
	-- BrowseResetButton:ClearAllPoints()
	-- BrowseResetButton:SetPoint("BOTTOMLEFT", BrowseSearchButton, "TOPLEFT", 0, 3)
	-- BrowseResetButton:SetWidth(80)

	AuctionsItemButton:StripTextures()
	AuctionsItemButton:StyleButton(true)
	AuctionsItemButton:SetTemplate("Default")
	AuctionsItemButton.IconBorder:Kill()

	AuctionsItemButton:HookScript("OnEvent", function(self, event, ...)
		if event == "NEW_AUCTION_UPDATE" and self:GetNormalTexture() then
			self:GetNormalTexture():SetTexCoord(0.1, 0.9, 0.1, 0.9)
			self:GetNormalTexture():ClearAllPoints()
			self:GetNormalTexture():SetPoint("TOPLEFT", 2, -2)
			self:GetNormalTexture():SetPoint("BOTTOMRIGHT", -2, 2)
		end
	end)

	local sorttabs = {
		"BrowseQualitySort",
		"BrowseLevelSort",
		"BrowseDurationSort",
		"BrowseHighBidderSort",
		"BrowseCurrentBidSort",
		"BidQualitySort",
		"BidLevelSort",
		"BidDurationSort",
		"BidBuyoutSort",
		"BidStatusSort",
		"BidBidSort",
		"AuctionsQualitySort",
		"AuctionsDurationSort",
		"AuctionsHighBidderSort",
		"AuctionsBidSort"
	}

	for _, sorttab in pairs(sorttabs) do
		_G[sorttab.."Left"]:Kill()
		_G[sorttab.."Middle"]:Kill()
		_G[sorttab.."Right"]:Kill()
	end

	for i = 1, AuctionFrame.numTabs do
		T.SkinTab(_G["AuctionFrameTab"..i])
	end

	for i = 1, NUM_FILTERS_TO_DISPLAY do
		local tab = _G["AuctionFilterButton"..i]
		tab:StyleButton()
		_G["AuctionFilterButton"..i.."NormalTexture"]:SetAlpha(0)
		_G["AuctionFilterButton"..i.."NormalTexture"].SetAlpha = T.dummy
	end

	local editboxes = {
		"BrowseName",
		"BrowseMinLevel",
		"BrowseMaxLevel",
		"BrowseBidPriceGold",
		"BrowseBidPriceSilver",
		"BrowseBidPriceCopper",
		"BidBidPriceGold",
		"BidBidPriceSilver",
		"BidBidPriceCopper",
		"AuctionsStackSizeEntry",
		"AuctionsNumStacksEntry",
		"StartPriceGold",
		"StartPriceSilver",
		"StartPriceCopper",
		"BuyoutPriceGold",
		"BuyoutPriceSilver",
		"BuyoutPriceCopper"
	}

	for _, editbox in pairs(editboxes) do
		T.SkinEditBox(_G[editbox])
		_G[editbox]:SetTextInsets(1, 1, -1, 1)
		if editbox ~= "BrowseName" then
			_G[editbox]:SetWidth(_G[editbox]:GetWidth() + 4)
		else
			_G[editbox]:SetWidth(_G[editbox]:GetWidth() + 19)
		end
	end
	_G["BrowseName"]:SetTextInsets(15, 15, -1, 1)
	_G["BrowseNameText"]:ClearAllPoints()
	_G["BrowseNameText"]:SetPoint("TOPLEFT", _G["AuctionFrameBrowse"], "TOPLEFT", 19, -38)
	_G["BrowseLevelHyphen"]:SetPoint("LEFT", _G["BrowseMinLevel"], "RIGHT", 6, 0)
	_G["BrowseMaxLevel"]:SetPoint("LEFT", _G["BrowseLevelHyphen"], "RIGHT", 2, 0)
	if T.client == "zhCN" or T.client == "zhTW" then
		_G["BrowseMinLevel"]:ClearAllPoints()
		_G["BrowseMinLevel"]:SetPoint("LEFT", _G["BrowseName"], "RIGHT", 42, 0)
		_G["BrowseLevelText"]:ClearAllPoints()
		_G["BrowseLevelText"]:SetPoint("TOPLEFT", _G["BrowseMinLevel"], "TOPLEFT", -2, 16)
		_G["BrowseDropDown"]:ClearAllPoints()
		_G["BrowseDropDown"]:SetPoint("LEFT", _G["BrowseMaxLevel"], "RIGHT", 4, -4)
		_G["BrowseDropDownName"]:ClearAllPoints()
		_G["BrowseDropDownName"]:SetPoint("TOPLEFT", _G["BrowseDropDown"], "TOPLEFT", 20, 12)
		_G["ShowOnPlayerCheckButton"]:ClearAllPoints()
		_G["ShowOnPlayerCheckButton"]:SetPoint("BOTTOMRIGHT", _G["BrowseSearchButton"], "BOTTOMRIGHT", 4, -26)
		_G["BrowseShowOnCharacterText"]:ClearAllPoints()
		_G["BrowseShowOnCharacterText"]:SetPoint("RIGHT", _G["ShowOnPlayerCheckButton"], "LEFT", -8, 0)
	end
	AuctionsStackSizeEntry.backdrop:SetAllPoints()
	AuctionsNumStacksEntry.backdrop:SetAllPoints()

	BrowseBidPriceGold.texture:SetDrawLayer("ARTWORK")
	BidBidPriceGold.texture:SetDrawLayer("ARTWORK")
	StartPriceGold.texture:SetDrawLayer("ARTWORK")
	BuyoutPriceGold.texture:SetDrawLayer("ARTWORK")

	for i = 1, NUM_BROWSE_TO_DISPLAY do
		local button = _G["BrowseButton"..i]
		local icon = _G["BrowseButton"..i.."Item"]

		if _G["BrowseButton"..i.."ItemIconTexture"] then
			_G["BrowseButton"..i.."ItemIconTexture"]:SetTexCoord(0.1, 0.9, 0.1, 0.9)
			_G["BrowseButton"..i.."ItemIconTexture"]:ClearAllPoints()
			_G["BrowseButton"..i.."ItemIconTexture"]:SetPoint("TOPLEFT", 2, -2)
			_G["BrowseButton"..i.."ItemIconTexture"]:SetPoint("BOTTOMRIGHT", -2, 2)
		end

		if icon then
			icon:StripTextures()
			icon:StyleButton()
			icon:CreateBackdrop("Default")
			icon.backdrop:SetAllPoints()
			icon.IconBorder:Kill()
		end

		if button then
			button:StripTextures()
			button:StyleButton()
			_G["BrowseButton"..i.."Highlight"] = button:GetHighlightTexture()
			button:GetHighlightTexture():ClearAllPoints()
			button:GetHighlightTexture():SetPoint("TOPLEFT", icon, "TOPRIGHT", 2, 0)
			button:GetHighlightTexture():SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 5)
			button:GetPushedTexture():SetAllPoints(button:GetHighlightTexture())
		end
	end

	for i = 1, NUM_AUCTIONS_TO_DISPLAY do
		local button = _G["AuctionsButton"..i]
		local icon = _G["AuctionsButton"..i.."Item"]

		_G["AuctionsButton"..i.."ItemIconTexture"]:SetTexCoord(0.1, 0.9, 0.1, 0.9)
		_G["AuctionsButton"..i.."ItemIconTexture"]:ClearAllPoints()
		_G["AuctionsButton"..i.."ItemIconTexture"]:SetPoint("TOPLEFT", 2, -2)
		_G["AuctionsButton"..i.."ItemIconTexture"]:SetPoint("BOTTOMRIGHT", -2, 2)

		icon:StripTextures()
		icon:StyleButton()
		icon:CreateBackdrop("Default")
		icon.backdrop:SetAllPoints()
		icon.IconBorder:Kill()

		button:StripTextures()
		button:StyleButton()
		_G["AuctionsButton"..i.."Highlight"] = button:GetHighlightTexture()
		button:GetHighlightTexture():ClearAllPoints()
		button:GetHighlightTexture():SetPoint("TOPLEFT", icon, "TOPRIGHT", 2, 0)
		button:GetHighlightTexture():SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 5)
		button:GetPushedTexture():SetAllPoints(button:GetHighlightTexture())
	end

	for i = 1, NUM_BIDS_TO_DISPLAY do
		local button = _G["BidButton"..i]
		local icon = _G["BidButton"..i.."Item"]

		_G["BidButton"..i.."ItemIconTexture"]:SetTexCoord(0.1, 0.9, 0.1, 0.9)
		_G["BidButton"..i.."ItemIconTexture"]:ClearAllPoints()
		_G["BidButton"..i.."ItemIconTexture"]:SetPoint("TOPLEFT", 2, -2)
		_G["BidButton"..i.."ItemIconTexture"]:SetPoint("BOTTOMRIGHT", -2, 2)

		icon:StripTextures()
		icon:StyleButton()
		icon:CreateBackdrop("Default")
		icon.backdrop:SetAllPoints()
		icon.IconBorder:Kill()

		button:StripTextures()
		button:StyleButton()
		_G["BidButton"..i.."Highlight"] = button:GetHighlightTexture()
		button:GetHighlightTexture():ClearAllPoints()
		button:GetHighlightTexture():SetPoint("TOPLEFT", icon, "TOPRIGHT", 2, 0)
		button:GetHighlightTexture():SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 5)
		button:GetPushedTexture():SetAllPoints(button:GetHighlightTexture())
	end

	-- Custom Backdrops
	AuctionFrameBrowse.bg1 = CreateFrame("Frame", nil, AuctionFrameBrowse)
	AuctionFrameBrowse.bg1:SetTemplate("Overlay")
	AuctionFrameBrowse.bg1:SetPoint("TOPLEFT", 20, -103)
	AuctionFrameBrowse.bg1:SetPoint("BOTTOMRIGHT", -575, 40)
	BrowseFilterScrollFrame:SetHeight(300)

	AuctionFrameBrowse.bg2 = CreateFrame("Frame", nil, AuctionFrameBrowse)
	AuctionFrameBrowse.bg2:SetTemplate("Overlay")
	AuctionFrameBrowse.bg2:SetPoint("TOPLEFT", AuctionFrameBrowse.bg1, "TOPRIGHT", 4, 0)
	AuctionFrameBrowse.bg2:SetPoint("BOTTOMRIGHT", AuctionFrame, "BOTTOMRIGHT", -8, 40)
	AuctionFrameBrowse.bg2:SetFrameLevel(AuctionFrameBrowse.bg2:GetFrameLevel() - 2)
	BrowseScrollFrame:SetHeight(300)

	AuctionFrameBid.bg = CreateFrame("Frame", nil, AuctionFrameBid)
	AuctionFrameBid.bg:SetTemplate("Overlay")
	AuctionFrameBid.bg:SetPoint("TOPLEFT", 22, -72)
	AuctionFrameBid.bg:SetPoint("BOTTOMRIGHT", 66, 40)
	AuctionFrameBid.bg:SetFrameLevel(AuctionFrameBid.bg:GetFrameLevel() - 2)
	BidScrollFrame:SetHeight(332)

	AuctionsScrollFrame:SetHeight(336)
	AuctionFrameAuctions.bg1 = CreateFrame("Frame", nil, AuctionFrameAuctions)
	AuctionFrameAuctions.bg1:SetTemplate("Overlay")
	AuctionFrameAuctions.bg1:SetPoint("TOPLEFT", 15, -70)
	AuctionFrameAuctions.bg1:SetPoint("BOTTOMRIGHT", -545, 35)
	AuctionFrameAuctions.bg1:SetFrameLevel(AuctionFrameAuctions.bg1:GetFrameLevel() - 2)

	AuctionFrameAuctions.bg2 = CreateFrame("Frame", nil, AuctionFrameAuctions)
	AuctionFrameAuctions.bg2:SetTemplate("Overlay")
	AuctionFrameAuctions.bg2:SetPoint("TOPLEFT", AuctionFrameAuctions.bg1, "TOPRIGHT", 3, 0)
	AuctionFrameAuctions.bg2:SetPoint("BOTTOMRIGHT", AuctionFrame, -8, 35)
	AuctionFrameAuctions.bg2:SetFrameLevel(AuctionFrameAuctions.bg2:GetFrameLevel() - 2)
end

T.SkinFuncs["Blizzard_AuctionUI"] = LoadSkin

-- Auctionator skin (from AddOnSkins)
local function LoadAuctionatorSkin()

	local function reskinButtons(self, buttons)
		for _, key in ipairs(buttons) do
			local bu = self[key]
			if bu then
				bu:SkinButton(true)
				T.ChangePoint(bu, -2, 0)
			end
		end
	end

	local function reskinItemDialog(self)
		self:StripTextures()
		self:CreateBackdrop("Transparent")
		T.SkinEditBox(self.SearchContainer.SearchString)
		T.SkinCheckBox(self.SearchContainer.IsExact)
		T.SkinDropDownBox(self.FilterKeySelector)
		T.SkinDropDownBox(self.QualityContainer.DropDown.DropDown)
		reskinButtons(self, {"Finished", "Cancel", "ResetAllButton"})

		if self.Inset then
			self.Inset:SetAlpha(0)
		end

		for _, key in ipairs({"LevelRange", "ItemLevelRange", "PriceRange", "CraftedLevelRange"}) do
			local minMax = self[key]
			if minMax then
				T.SkinEditBox(minMax.MaxBox)
				T.SkinEditBox(minMax.MinBox)
			end
		end
	end

	local function SkinHeaders(frame)
		local maxHeaders = frame:GetNumChildren()
		for i = 1, maxHeaders do
			local header = select(i, frame:GetChildren())
			if header and not header.IsSkinned then
				header:DisableDrawLayer("BACKGROUND")
				header:GetHighlightTexture():Hide()
				header:CreateBackdrop("Overlay")
				header.backdrop:SetPoint("TOPLEFT", 2, 0)
				header.backdrop:SetPoint("BOTTOMRIGHT", 0, 0)

				header.IsSkinned = true
			end
		end
	end

	local function reskinListHeader(frame)
		if not frame or not frame.tableBuilder then return end

		frame.ScrollFrame:CreateBackdrop("Overlay")
		frame.ScrollFrame.backdrop:SetPoint("TOPLEFT", 2, 0)
		frame.ScrollFrame.backdrop:SetPoint("BOTTOMRIGHT", 0, 0)
		frame.ScrollFrame.backdrop:SetPoint("TOPLEFT", 2, 0)
		frame.ScrollFrame.backdrop:SetPoint("BOTTOMRIGHT", -2, 0)
		T.SkinScrollBar(frame.ScrollFrame.scrollBar)

		for _, column in ipairs(frame.tableBuilder.columns) do
			local header = column.headerFrame
			if header and not header.IsSkinned then
				header:DisableDrawLayer("BACKGROUND")
				header:GetHighlightTexture():Hide()
				header:CreateBackdrop("Overlay")
				header.backdrop:SetPoint("TOPLEFT", 2, 0)
				header.backdrop:SetPoint("BOTTOMRIGHT", -2, 0)

				header.IsSkinned = true
			end
		end

		for _, row in ipairs(frame.tableBuilder.rows) do
			local cells = row.cells
			if cells then
				for _, cell in ipairs(cells) do
					if cell.Icon then
						cell.Icon:StyleButton(true)
					end
				end
			end
		end
	end

	local function reskinSimplePanel(frame)
		if not frame then return end

		frame:StripTextures()
		frame:CreateBackdrop("Transparent")

		if frame.ScrollFrame then
			T.SkinScrollBar(frame.ScrollFrame.ScrollBar)
		end

		if frame.CloseDialog then
			T.SkinCloseButton(frame.CloseDialog)
		end

		if frame.Inset then
			frame.Inset:SetAlpha(0)
		end
	end

	local function reskinInput(editbox)
		if not editbox then return end
		T.SkinEditBox(editbox, 50, 15)
	end

	local function reskinBagItem(button)
		if not button then return end

		button.IconMask:Hide()
		button.EmptySlot:Hide()
		button:SetPushedTexture("")
		button.Icon:SetInside(button, 2, 2)
		button.Highlight:SetColorTexture(1, 1, 1, .25)
		button.Highlight:SetAllPoints(button.Icon)

		button:StripTextures()
		button:CreateBackdrop("Overlay")
		button.backdrop:SetPoint("TOPLEFT", 1, -1)
		button.backdrop:SetPoint("BOTTOMRIGHT", -1, 1)
		button.backdrop:SetBackdropColor(0, 0, 0, 0.7)
		button.backdrop:SetBackdropBorderColor(0, 0, 0)

		hooksecurefunc(button.IconBorder, "SetVertexColor", function(self, r, g, b)
			button.backdrop:SetBackdropBorderColor(r, g, b)
		end)

	end

	local function reskinBagList(frame)
		frame.SectionTitle:StripTextures()

		local buttons = frame.ItemContainer and frame.ItemContainer.buttons
		if buttons then
			for _, bu in ipairs(buttons) do
				reskinBagItem(bu)
				bu.styled = true
			end
		end

		local buttonPool = frame.ItemContainer and frame.ItemContainer.buttonPool
		if buttonPool then
			local origGet = buttonPool.Get
			buttonPool.Get = function(self)
				local button = origGet(self)
				if not button.styled then
					reskinBagItem(button)
					button.styled = true
				end
				return button
			end
		end
	end

	local function reskinMoneyInput(self)
		if not self or not self.MoneyInput then return end

		for _, key in ipairs({"GoldBox", "SilverBox", "CopperBox"}) do
			local box = self.MoneyInput[key]
			if box then
				reskinInput(box)
			end
		end
	end

	local function reskinBuyFrame(self)
		if not self then return end

		reskinListHeader(self.SearchResultsListing)
		reskinListHeader(self.HistoryResultsListing)

		if self.Inset then
			self.Inset:SetAlpha(0)
		end

		for _, key in ipairs({"HistoryButton", "CancelButton", "BuyButton", "RefreshButton"}) do
			local bu = self[key]
			if bu then
				bu:SkinButton(true)
				if (key == "HistoryButton" or key == "CancelButton") and self.SearchResultsListing then
					bu:SetPoint("TOP", self.SearchResultsListing, "BOTTOM", 0, -2)
				end
				T.ChangePoint(bu, -2, 0)
			end
		end

		local BuyDialog = self.BuyDialog
		if BuyDialog then
			reskinSimplePanel(BuyDialog)
			reskinButtons(BuyDialog, {"Cancel", "BuyStack"})
			T.SkinCheckBox(BuyDialog.ChainBuy.CheckBox, 30)
		end
	end
	-- Auctionator (Retail)
	local Auctionator = _G.Auctionator
	if not Auctionator or not _G.AuctionatorInitalizeClassicFrame or not _G.AuctionatorInitalizeClassicFrame.AuctionHouseShown then return end

	local styled
	hooksecurefunc(_G.AuctionatorInitalizeClassicFrame, "AuctionHouseShown", function()
		if styled then return end

		local SplashScreen = _G.AuctionatorSplashScreen
		if SplashScreen then
			SplashScreen:StripTextures()
			SplashScreen:CreateBackdrop("Overlay")
			T.SkinScrollBar(SplashScreen.ScrollFrame.ScrollBar)
			T.SkinCheckBox(SplashScreen.HideCheckbox.CheckBox)

			if SplashScreen.Inset then
				SplashScreen.Inset:SetAlpha(0)
			end
		end

		local ShoppingList = _G.AuctionatorShoppingFrame
		if ShoppingList then
			reskinListHeader(ShoppingList.ResultsListing)
			reskinButtons(ShoppingList, {"Import", "Export", "AddItem", "ManualSearch", "ExportCSV", "OneItemSearchButton", "SortItems"})

			if ShoppingList.ListDropdown then
				T.SkinDropDownBox(ShoppingList.ListDropdown)
			end

			T.ChangePoint(ShoppingList.OneItemSearchButton, 8, 0)

			local itemDialog = ShoppingList.itemDialog
			if itemDialog then
				reskinItemDialog(itemDialog)
			end

			local exportDialog = ShoppingList.exportDialog
			if exportDialog then
				reskinSimplePanel(exportDialog)
				reskinButtons(exportDialog, {"Export", "SelectAll", "UnselectAll"})

				for _, cb in ipairs(exportDialog.checkBoxPool) do
					T.SkinCheckBox(cb.CheckBox)
				end

				hooksecurefunc(exportDialog, "AddToPool", function(self)
					T.SkinCheckBox(self.checkBoxPool[#self.checkBoxPool].CheckBox)
				end)
			end

			local importDialog = ShoppingList.importDialog
			if importDialog then
				reskinSimplePanel(importDialog)
				importDialog.Import:SkinButton(true)
			end

			if ShoppingList.ShoppingResultsInset then
				ShoppingList.ShoppingResultsInset:SetAlpha(0)
			end

			for _, key in ipairs({"ScrollListShoppingList", "ScrollListRecents"}) do
				local scrollList = ShoppingList[key]
				if scrollList and scrollList.ScrollFrame then
					scrollList:StripTextures()
					scrollList.ScrollFrame:CreateBackdrop("Overlay")
					scrollList.ScrollFrame.backdrop:SetPoint("TOPLEFT", -6, 2)
					scrollList.ScrollFrame.backdrop:SetPoint("BOTTOMRIGHT", 2, 1)
					T.SkinScrollBar(scrollList.ScrollFrame.scrollBar)
				end
			end

			local OneItemSearchBox = ShoppingList.OneItemSearchBox
			if OneItemSearchBox then
				T.SkinEditBox(OneItemSearchBox, 180, 20)
			end

			local OneItemSearchExtendedButton = ShoppingList.OneItemSearchExtendedButton
			if OneItemSearchExtendedButton then
				T.ChangePoint(OneItemSearchExtendedButton, 2, 0)
				OneItemSearchExtendedButton:SkinButton()
			end

			local TabsContainer = ShoppingList.RecentsTabsContainer
			if TabsContainer then
				for _, tab in ipairs(TabsContainer.Tabs) do
					tab:StripTextures()
					T.SkinTab(tab, true)
				end

				if ShoppingList.ScrollListShoppingList then
					TabsContainer:ClearAllPoints()
					TabsContainer:SetPoint("TOPLEFT", ShoppingList.ScrollListShoppingList, "TOPLEFT", -5, 30)
					TabsContainer:SetPoint("BOTTOMRIGHT", ShoppingList.ScrollListShoppingList, "TOPRIGHT", 0, 0)
				end
			end

			local exportCSVDialog = ShoppingList.exportCSVDialog
			if exportCSVDialog then
				reskinSimplePanel(exportCSVDialog)
				exportCSVDialog.Close:SkinButton(true)
			end

			local itemHistoryDialog = ShoppingList.itemHistoryDialog
			if itemHistoryDialog then
				reskinSimplePanel(itemHistoryDialog)
				reskinListHeader(itemHistoryDialog.ResultsListing)
				reskinButtons(itemHistoryDialog, {"Close", "Dock"})
			end
		end

		local BuyFrame = _G.AuctionatorBuyFrame
		if BuyFrame then
			reskinBuyFrame(BuyFrame)
			if BuyFrame.ReturnButton then
				BuyFrame.ReturnButton:SkinButton(true)
			end

			local relF, parent, relT, xoffset, yoffset = BuyFrame.BuyButton:GetPoint()
			BuyFrame.BuyButton:SetPoint("RIGHT", parent, relT, -2 , yoffset)

			for _, child in pairs {BuyFrame:GetChildren()} do
				if child.Icon and child.IconMask then
					child.Icon:SkinIcon()
					child.IconMask:Hide()
				end
			end
		end

		local SellingFrame = _G.AuctionatorSellingFrame
		if SellingFrame then
			local SaleItemFrame = SellingFrame.SaleItemFrame
			if SaleItemFrame then
				reskinBagItem(SaleItemFrame.Icon)
				reskinMoneyInput(SaleItemFrame.StackPrice)
				reskinMoneyInput(SaleItemFrame.UnitPrice)
				reskinMoneyInput(SaleItemFrame.BidPrice)
				reskinButtons(SaleItemFrame, {"PostButton", "SkipButton"})

				local Duration = SaleItemFrame.Duration
				if Duration and Duration.radioButtons then
					for _, bu in ipairs(Duration.radioButtons) do
						T.SkinCheckBox(bu.RadioButton)
					end
				end

				local Stacks = SaleItemFrame.Stacks
				if Stacks then
					reskinInput(Stacks.NumStacks)
					reskinInput(Stacks.StackSize)
				end
			end

			local BagListing = SellingFrame.BagListing
			if BagListing and BagListing.ScrollFrame then
				BagListing.ScrollFrame:StripTextures()
				BagListing.ScrollFrame:CreateBackdrop("Overlay")
				BagListing.ScrollFrame.backdrop:SetPoint("TOPLEFT", -2, 3)
				BagListing.ScrollFrame.backdrop:SetPoint("BOTTOMRIGHT", 3, -1)
				T.SkinScrollBar(BagListing.ScrollFrame.ScrollBar)

				local frameMap = BagListing.frameMap
				if frameMap then
					for _, items in pairs(frameMap) do
						reskinBagList(items)
					end
				end
			end

			if SellingFrame.BagInset then
				SellingFrame.BagInset:SetAlpha(0)
			end

			local SellingBuyFrame = SellingFrame.BuyFrame
			if SellingBuyFrame then
				reskinBuyFrame(SellingBuyFrame)

				local relF, parent, relT, xoffset, yoffset = SellingBuyFrame.BuyButton:GetPoint()
				SellingBuyFrame.BuyButton:SetPoint("RIGHT", parent, relT, -2 , yoffset)
			end
		end

		local CancellingFrame = _G.AuctionatorCancellingFrame
		if CancellingFrame then
			reskinListHeader(CancellingFrame.ResultsListing)

			for _, child in pairs {CancellingFrame:GetChildren()} do
				if child.StartScanButton then
					child.StartScanButton:SkinButton(true)
					T.ChangePoint(child.StartScanButton, -5, 0)
				end
				if child.CancelNextButton then
					child.CancelNextButton:SkinButton(true)
				end
			end

			if CancellingFrame.HistoricalPriceInset then
				CancellingFrame.HistoricalPriceInset:Hide()
			end

			if CancellingFrame.SearchFilter then
				T.SkinEditBox(CancellingFrame.SearchFilter, 200, 20)
			end
		end

		local ConfigFrame = _G.AuctionatorConfigFrame
		if ConfigFrame then
			ConfigFrame:StripTextures()
			ConfigFrame:CreateBackdrop("Overlay")
			ConfigFrame.backdrop:SetPoint("TOPLEFT", 1, 0)
			ConfigFrame.backdrop:SetPoint("BOTTOMRIGHT", -5, 4)
			reskinButtons(ConfigFrame, {"ScanButton", "OptionsButton"})

			for _, key in ipairs({"DiscordLink", "BugReportLink", "TechnicalRoadmap"}) do
				local eb = ConfigFrame[key]
				if eb then
					T.SkinEditBox(eb.InputBox)
				end
			end

			for _, child in pairs {ConfigFrame:GetChildren()} do
				if child:GetObjectType() == "Frame" and child.BorderTopRight then
					child:SetAlpha(0)
				end
			end
		end

		local PageStatusDialogFrame = _G.AuctionatorPageStatusDialogFrame
		if PageStatusDialogFrame then
			PageStatusDialogFrame:StripTextures()
			PageStatusDialogFrame:CreateBackdrop("Transparent")
		end

		for _, tab in ipairs(_G.AuctionatorAHTabsContainer.Tabs) do
			T.SkinTab(tab)
		end

		styled = true
	end)

	if Auctionator.ReagentSearch and Auctionator.ReagentSearch.InitializeSearchButton then
		hooksecurefunc(Auctionator.ReagentSearch, "InitializeSearchButton", function()
			local button = _G.AuctionatorTradeSkillSearch
			if button and not button.styled then
				button:SkinButton(true)
				button.styled = true
			end
		end)
	end

	if Auctionator.CraftSearch and Auctionator.CraftSearch.InitializeSearchButton then
		hooksecurefunc(Auctionator.CraftSearch, "InitializeSearchButton", function()
			local button = _G.AuctionatorCraftFrameSearch
			if button and not button.styled then
				button:SkinButton(true)
				button.styled = true
			end
		end)
	end
end

tinsert(T.SkinFuncs["ShestakUI"], LoadAuctionatorSkin)