local T, C, L, _ = unpack(select(2, ...))
if C.skins.blizzard_frames ~= true or IsAddOnLoaded("QuestLogEx") then return end -- incomplete

----------------------------------------------------------------------------------------
--	QuestLog skin
----------------------------------------------------------------------------------------
local function LoadSkin()
	local QuestStrip = {
		"QuestLogFrame",
		"QuestLogCount",
		"QuestLogQuestCount",
		"EmptyQuestLogFrame",
		"QuestLogDetailFrame",
	}

	for i = 1, getn(QuestStrip) do
		local object = _G[QuestStrip[i]]
		if object then
			object:StripTextures(true)
		end
	end

	QuestLogFrame:SetAttribute("UIPanelLayout-width", T.Scale(685))
	QuestLogFrame:SetAttribute("UIPanelLayout-height", T.Scale(490))
	QuestLogFrame:SetSize(685, 490)
	QuestLogFrame:CreateBackdrop("Transparent")
	QuestLogFrame.backdrop:SetPoint("TOPLEFT", 10, -12)
	QuestLogFrame.backdrop:SetPoint("BOTTOMRIGHT", -1, 8)

	QuestLogFrame:DisableDrawLayer("BACKGROUND")

	QuestLogDetailFrame:SetAttribute("UIPanelLayout-width", T.Scale(685))
	QuestLogDetailFrame:SetAttribute("UIPanelLayout-height", T.Scale(490))
	QuestLogDetailFrame:SetSize(350, 490)
	QuestLogDetailFrame:CreateBackdrop("Transparent")
	QuestLogDetailFrame.backdrop:SetPoint("TOPLEFT", 10, -12)
	QuestLogDetailFrame.backdrop:SetPoint("BOTTOMRIGHT", -1, 8)

	QuestLogDetailFrame:DisableDrawLayer("BACKGROUND")

	QuestLogTitleText:ClearAllPoints()
	QuestLogTitleText:SetPoint("TOP", QuestLogFrame.backdrop, "TOP", 0, -6)

	QuestLogDetailTitle:ClearAllPoints()
	QuestLogDetailTitle:SetPoint("TOP", QuestLogDetailFrame.backdrop, "TOP", 0, -16)

	T.SkinCloseButton(QuestLogFrameCloseButton)
	QuestLogFrameCloseButton:ClearAllPoints()
	QuestLogFrameCloseButton:SetPoint("TOPRIGHT", -5, -16)

	T.SkinCloseButton(QuestLogDetailFrameCloseButton)
	QuestLogDetailFrameCloseButton:ClearAllPoints()
	QuestLogDetailFrameCloseButton:SetPoint("TOPRIGHT", -5, -16)

	QuestLogListScrollFrame:StripTextures()
	QuestLogListScrollFrame:CreateBackdrop("Default", true)
	QuestLogListScrollFrame.backdrop:SetPoint("TOPLEFT", -4, 4)
	QuestLogListScrollFrame:SetSize(301, 373)

	QuestLogDetailScrollFrame:StripTextures()
	QuestLogDetailScrollFrame:CreateBackdrop("Default", true)

	QuestLogFrame:HookScript("OnShow", function() 
		QuestLogDetailScrollFrame:ClearAllPoints()
		QuestLogDetailScrollFrame:SetPoint("TOPRIGHT", QuestLogFrame, -32, -73)
		QuestLogDetailScrollFrame.backdrop:SetPoint("TOPLEFT", -4, 2)
		QuestLogDetailScrollFrame:SetSize(300, 370)
		QuestLogFrameAbandonButton:ClearAllPoints()
		QuestLogFrameAbandonButton:SetPoint("BOTTOMLEFT", QuestLogFrame, 18, 15)
	end)

	QuestLogDetailFrame:HookScript("OnShow", function()
		QuestLogDetailScrollFrame:ClearAllPoints()
		QuestLogDetailScrollFrame:SetPoint("TOPRIGHT", QuestLogDetailFrame, -30, -73)
		QuestLogDetailScrollFrame.backdrop:SetPoint("TOPLEFT", -4, 2)
		QuestLogDetailScrollFrame:SetSize(300, 370)
		QuestLogFrameAbandonButton:ClearAllPoints()
		QuestLogFrameAbandonButton:SetPoint("BOTTOMLEFT", QuestLogDetailFrame, 18, 15)
	end)

	QuestLogDetailScrollFrame:DisableDrawLayer("BACKGROUND")

	QuestLogNoQuestsText:ClearAllPoints()
	QuestLogNoQuestsText:SetPoint("CENTER", EmptyQuestLogFrame, "CENTER", -45, 65)
	
	QuestLogFrameAbandonButton:SetWidth(99)
	QuestLogFrameAbandonButton:SetText(ABANDON_QUEST)

	QuestFramePushQuestButton:ClearAllPoints()
	QuestFramePushQuestButton:SetPoint("LEFT", QuestLogFrameAbandonButton, "RIGHT", 2, 0)
	QuestFramePushQuestButton:SetWidth(99)
	QuestFramePushQuestButton:SetText(SHARE_QUEST)

	QuestLogFrameTrackButton:ClearAllPoints()
	QuestLogFrameTrackButton:SetPoint("LEFT", QuestFramePushQuestButton, "RIGHT", 2, 0)
	QuestLogFrameTrackButton:SetWidth(99)
	QuestLogFrameTrackButton:SetText(TRACK_QUEST)

	T.SkinScrollBar(QuestLogDetailScrollFrameScrollBar)
	T.SkinScrollBar(QuestLogListScrollFrameScrollBar)
	QuestLogListScrollFrameScrollBar:SetPoint("TOPLEFT", QuestLogListScrollFrame, "TOPRIGHT", 5, -16)


	QuestLogCount:ClearAllPoints()
	QuestLogCount:SetPoint("TOPRIGHT", QuestLogFrame, "TOPRIGHT", -590, 0)

	local QuestButtons = {
		"QuestLogFrameAbandonButton",
		"QuestLogFrameTrackButton",
		"QuestFramePushQuestButton",
		"QuestLogFrameCancelButton",
	}

	for i = 1, getn(QuestButtons) do
		local object = _G[QuestButtons[i]]
		if object then
			object:StripTextures()
			object:SkinButton()
		end
	end

	local function QuestQualityColors(frame, text, quality, link)
		if link and not quality then
			quality = select(3, GetItemInfo(link))
		end

		if frame then
			Mixin(frame, BackdropTemplateMixin) -- 9.0 to set backdrop
		end

		if quality then
			if frame then
				frame:SetBackdropBorderColor(GetItemQualityColor(quality))
			end
			text:SetTextColor(GetItemQualityColor(quality))
		else
			if frame then
				frame:SetBackdropBorderColor(unpack(C.media.backdrop_color))
			end
			text:SetTextColor(1, 1, 1)
		end
	end

	hooksecurefunc("QuestRewardItem_OnClick", function()
		QuestRewardItemHighlight:ClearAllPoints();
		QuestRewardItemHighlight:SetOutside(this:GetName().."IconTexture")
		_G[this:GetName().."Name"]:SetTextColor(1, 1, 0)

		for i = 1, MAX_NUM_ITEMS do
			local questItem = _G["QuestRewardItem"..i]
			local questName = _G["QuestRewardItem"..i.."Name"]
			local link = questItem.type and GetQuestItemLink(questItem.type, questItem:GetID())

			if questItem ~= this then
				QuestQualityColors(nil, questName, nil, link)
			end
		end
	end)

	for i = 1, 20 do
		local questLogTitle = _G["QuestLogListScrollFrameButton"..i]
		local highlight = _G["QuestLogListScrollFrameButton"..i.."Highlight"]
		highlight:SetTexture()
		hooksecurefunc(questLogTitle, "SetNormalTexture", function(self, texture)
			local tex = self:GetNormalTexture()

			if strfind(texture, 'MinusButton') then
				tex:SetTexture(C.media.Minus)
			elseif strfind(texture, 'PlusButton') then
				tex:SetTexture(C.media.Plus)
			else
				tex:SetTexture()
			end
		end)
	end

	local function colourObjectivesText()
		if not QuestInfoFrame.questLog then return end

		local objectivesTable = QuestInfoObjectivesFrame.Objectives
		local numVisibleObjectives = 0

		for i = 1, GetNumQuestLeaderBoards() do
			local _, type, finished = GetQuestLogLeaderBoard(i)

			if (type ~= "spell" and type ~= "log" and numVisibleObjectives < MAX_OBJECTIVES) then
				numVisibleObjectives = numVisibleObjectives + 1
				local objective = objectivesTable[numVisibleObjectives]

				if objective then
					if finished then
						objective:SetTextColor(.9, .9, .9)
					else
						objective:SetTextColor(1, 1, 1)
					end
				end
			end
		end
	end

	hooksecurefunc("QuestInfo_Display", function()
		colourObjectivesText()

        local rewardsFrame = QuestInfoFrame.rewardsFrame
        local isQuestLog = QuestInfoFrame.questLog ~= nil
		local numSpellRewards = isQuestLog and GetNumQuestLogRewardSpells() or GetNumRewardSpells()

		if numSpellRewards > 0 then
			-- Spell Headers
			for spellHeader in rewardsFrame.spellHeaderPool:EnumerateActive() do
				spellHeader:SetVertexColor(1, 1, 1)
			end
		end
	end)
end

table.insert(T.SkinFuncs["ShestakUI"], LoadSkin)